#!/bin/bash
#  Copyright 2009 Vasileios Lourdas (http://www.lourdas.name)
#  version 0.1
#  A handy BASH script to rename all those photos with the DSC_xyzv.ext
#  filename notation to filenames with a more meaningful name.
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

if [ -z "$1" ]; then
	echo "`basename $0`, Copyright 2009, Vasileios Lourdas (http://www.lourdas.name).
Distributed under the terms of the GNU General Public License v3"
	echo -e
	echo "Usage: `basename $0` <filename extension>"
	echo "	where <filename extension> is the filename extension of your photos.
	In order for the script to work, the photos must contain the EXIF information as saved by your digital camera."
	echo -e
	exit 1
else
	let counter=1
	for i in *.$1; do
		echo Processing file "$i"...
		newname=`exiftool -EXIF:DateTimeOriginal $i|awk '{print $4":"$5}'|tr -d :`
		if [ -e "$newname.$1" ]; then
			echo Existing file found! Renaming file to "$newname"#"$counter"."$1"...
			mv "$newname.$1" "$newname"#"$counter"."$1"

			let counter+=1
			echo Renaming original file \("$i"\) to "$newname"#"$counter"."$1"...
			mv "$i" "$newname"#"$counter"."$1"
		else
			let counter=1
			echo Renaming "$i" to "$newname"."$1"...
			mv "$i" "$newname"."$1"
		fi
	done
fi

echo -e
echo "Thanks for using `basename $0`!"
echo -e
